#include <windows.h>
#include <2D_World.h>
#include <2D_Sprite.h>
#include <2D_SpriteCache.h>
#include <CON_Console.h>
#include <CON_RetVal.h>
#include "CON_Keys.h"
#include "GameSprites.h"
#include "FPSCounter.h"

FPSCounter FPS;

int initConsole(int& Width, int& Height, int& FullScreen, int& NoAccel, Screen* S)
{
  Width=320;
  Height=240;
  if (S->isModeAvailable(Width,Height)==0)
  {
    MessageBox(NULL,"Resolution 320x240 not supported.","ERROR",MB_OK);
    return -1;
  }
  FullScreen=1;
  NoAccel=0;
#ifdef DEBUG
  setDebugLevel(3);
  enableDiagnostics();
#endif
  return 0;
}

World2D* W=NULL;
SpriteCache* SC=NULL;

int action(Console* C)
{
  Keyboard& K=*(C->getKeyboard());
  K.update();
  Screen* S=C->getScreen();
  S->clear(0);
  if (W==NULL)
  {
    W=new World2D();
    
    ResourceStream *RS=newResourceStream("ufo.rsc");
    setDefaultResourceStream(RS);
    SC=new SpriteCache(*RS);
    W->add(new Player(W,SC,C));
    W->add(new UFO(W,SC));
    
    //Bitmap* BM=newBitmap(16,16,1);  // Test for diagnostics.
  }

  float Fraction=getFrameTime();
  W->advance(Fraction);
  W->render();

  FPS.update(GetTickCount());
  S->beginDraw();
  S->printXY(10,5,0xffffffff,FPS.getFPSString());
  S->printXY(130,5,0xffffffff,"Left|Right|Space|F12");
  S->endDraw();
  S->flip();

  if (K[DIK_ESCAPE])
  {
    //RS->release();
    delete SC;
    delete W;
    return -1;
  }
  return 0;
}