#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <CON_Exports.h>
#include <2D_World.h>
#include <2D_Object2D.h>
#include <2D_Sprite.h>
#include <CON_Keys.h>
#include <stdio.h>

int initConsole(int& Width, int& Height, int& FullScreen, int& NoAccel, Screen* S)
{
  if (!S->isModeAvailable(640,480))
  {
    MessageBox(NULL,"Mode 640x480x16 not available","ERROR",MB_OK);
    return -1;
  }
  Width=640;
  Height=480;
  FullScreen=0;
  NoAccel=1;
  setDebugLevel(4);
  enableDiagnostics();
  return 0;
}

class MyObj : public Object2D
{
public:
  MyObj(World2D* W) : Object2D(W,NULL), dx(1), cnt(0)
  {
    m_BM=newBitmap(32,32);
    m_BM->clear(0xf274);
    m_SpriteSelector=m_Sprite=new Sprite(m_BM);
  }
  long advance(float Fraction)
  {
    fVector2D v=getPosition();
    v.x+=dx;
    setPosition(v);
    cnt++;
    if ((cnt&0x3f)==0) dx=-dx;
    return 0;
  }

  ~MyObj() { delete m_Sprite; m_BM->release(); }
  Sprite* m_Sprite;
  Bitmap* m_BM;
  int     dx,cnt;
};

World2D* W=NULL;
MyObj* O;
float Num=0.0f;

int action(Console* C)
{
  Screen* S=C->getScreen();
  Drawable* D=S;
  if (W==NULL)
  {
    W=new World2D();
    O=new MyObj(W);
    O->setPosition(fVector2D(100.0f,100.0f));
    W->add(O);
  }

  S->clear(0);


  W->advance(getFrameTime());
  W->render();

  S->beginDraw();
  char buf[128];
  sprintf(buf,"Hello %d",(int)(Num+=0.01f));
  S->printXY(500,50,0xffffffff,buf);
  S->endDraw();
  S->flip();
  Keyboard& K=*C->getKeyboard();
  K.update();
  if (K[DIK_ESCAPE])
  {
    delete W;
    return 1;
  }
  return 0;
}