/** \file 3D_ColDet.h
    Collision detection for 3D Objects.

Copyright (c) 1998-1999 by Amir Geva.
This file is part of the Photon Game Development library,
beta release version 0.21.  
Permission is granted to use and copy this file for non-commercial use only.  
Please contact the author concerning commercial usage. 
Amir Geva makes no representations about the suitability of this software for any purpose.
It is provided "as is" without express or implied warranty.

*/
#ifndef H_3D_COLDET
#define H_3D_COLDET

#include <WO_Collision.h>

/** This class provides mechanizm of checking for collisions between objects.
    It is used automatically by the World3D
    It uses the libCON Mesh collision detection (RAPID) to test collision
    between two objects. */
class CollisionDetection3D : public CollisionDetection
{
public:
  virtual int isCollision(Object* O1, Object* O2);
};

#endif // H_3D_COLDET