/** \file DS_Container.h
    Generic container class.

Copyright (c) 1998-1999 by Amir Geva.
This file is part of the Photon Game Development library,
beta release version 0.21.  
Permission is granted to use and copy this file for non-commercial use only.  
Please contact the author concerning commercial usage. 
Amir Geva makes no representations about the suitability of this software for any purpose.
It is provided "as is" without express or implied warranty.

*/
#ifndef H_DS_CONTAINER
#define H_DS_CONTAINER

#include <DS_SpecContainable.h>

/** Abstract container. 
    This class will not be very useful directly. */
class Container : public Serial_Containable
{
public:
  enum {
    DESTRUCTIVE           = 0x00000010
  };

  Container(unsigned Flags) : m_Flags(Flags)
  {}
  virtual ~Container() {}

  /** Returns the number of elements in the container. */
  virtual int size() const = 0;

  /** Checks validity of an element index.  
      Returns a non zero value if the index is valid. */
  virtual int isValidIndex(const int i) const { return (i>=0 && i<size()); } 

protected:
  unsigned m_Flags;
};


#endif // H_DS_CONTAINER