/** \file DS_Queue.h
    FIFO Data structure.

Copyright (c) 1998-1999 by Amir Geva.
This file is part of the Photon Game Development library,
beta release version 0.21.  
Permission is granted to use and copy this file for non-commercial use only.  
Please contact the author concerning commercial usage. 
Amir Geva makes no representations about the suitability of this software for any purpose.
It is provided "as is" without express or implied warranty.

*/
#ifndef H_DS_QUEUE
#define H_DS_QUEUE

#include "DS_Stack.h"

/** A classic FIFO data structure
    See stack for other methods */
class Queue : public Stack
{
public:
  Queue(unsigned Flags) : Stack(Flags)
  {}
 
  /** Retrieve the first element without removing. */
  Data peek()            { return elementAt(0); }

  /** Retrieve and remove the first element.
      Note: pop() returns garbage in a destructive queue. */
  Data pop()             { Data Item=peek(); removeElement(0); return Item; }
};

#endif // H_DS_QUEUE