/** \file WO_World.h
    Generic World that contains Objects.

Copyright (c) 1998-1999 by Amir Geva.
This file is part of the Photon Game Development library,
beta release version 0.21.  
Permission is granted to use and copy this file for non-commercial use only.  
Please contact the author concerning commercial usage. 
Amir Geva makes no representations about the suitability of this software for any purpose.
It is provided "as is" without express or implied warranty.

*/
#ifndef H_WO_WORLD
#define H_WO_WORLD

#include <WO_Object.h>


/** Generic Objects' World.  Provides a root to the objects' tree. */
class World : public Object
{
public:
  /** Construct a world. */
  World() : Object(NULL,NULL) { m_World=this; }

  /** Overridden to actually remove all objects that were
      removed in this advance cycle. */
  virtual long postAdvance(float Fraction);
};

#endif // H_WO_WORLD